commit 56ce663146b436ff1a267ee2a9701b7d5e190e62
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Tue Jun 30 23:36:56 2020 +0200

    PR fortran/88379 - ICE with allocatable coarray, class and associate
    
    Catch NULL pointer dereference for ASSOCIATE on allocatable coarray variable.
    
    gcc/fortran/
            PR fortran/88379
            * resolve.c (resolve_assoc_var): Avoid NULL pointer dereference.
    
    (cherry picked from commit 267f84c6035c9380c8d1e9cb83ffe299c23e3a85)

diff --git a/gcc/fortran/resolve.c b/gcc/fortran/resolve.c
index e3212ff55d2..462d07351ad 100644
--- a/gcc/fortran/resolve.c
+++ b/gcc/fortran/resolve.c
@@ -8731,7 +8731,7 @@ resolve_assoc_var (gfc_symbol* sym, bool resolve_target)
 	  as = NULL;
 	  sym->ts = *ts;
 	  sym->ts.type = BT_CLASS;
-	  attr = CLASS_DATA (sym)->attr;
+	  attr = CLASS_DATA (sym) ? CLASS_DATA (sym)->attr : sym->attr;
 	  attr.class_ok = 0;
 	  attr.associate_var = 1;
 	  attr.dimension = attr.codimension = 0;
diff --git a/gcc/testsuite/gfortran.dg/pr88379.f90 b/gcc/testsuite/gfortran.dg/pr88379.f90
new file mode 100644
index 00000000000..48a23af50c5
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr88379.f90
@@ -0,0 +1,11 @@
+! { dg-do compile }
+! { dg-options "-fcoarray=single" }
+! PR fortran/88379 - ICE with allocatable coarray, class and associate
+
+program p
+  type t
+  end type t
+  class(t), allocatable :: x[:]
+  associate (y => x)
+  end associate
+end

